-- ==============================================================
-- RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
-- Version: 2017.2
-- Copyright (C) 1986-2017 Xilinx, Inc. All Rights Reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity Block_proc is
port (
    ap_clk : IN STD_LOGIC;
    ap_rst : IN STD_LOGIC;
    ap_start : IN STD_LOGIC;
    ap_done : OUT STD_LOGIC;
    ap_continue : IN STD_LOGIC;
    ap_idle : OUT STD_LOGIC;
    ap_ready : OUT STD_LOGIC;
    img_in_rows_V_out_din : OUT STD_LOGIC_VECTOR (9 downto 0);
    img_in_rows_V_out_full_n : IN STD_LOGIC;
    img_in_rows_V_out_write : OUT STD_LOGIC;
    img_in_cols_V_out_din : OUT STD_LOGIC_VECTOR (10 downto 0);
    img_in_cols_V_out_full_n : IN STD_LOGIC;
    img_in_cols_V_out_write : OUT STD_LOGIC );
end;


architecture behav of Block_proc is 
    constant ap_const_logic_1 : STD_LOGIC := '1';
    constant ap_const_logic_0 : STD_LOGIC := '0';
    constant ap_ST_fsm_state1 : STD_LOGIC_VECTOR (0 downto 0) := "1";
    constant ap_const_lv32_0 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000000";
    constant ap_const_lv10_1E0 : STD_LOGIC_VECTOR (9 downto 0) := "0111100000";
    constant ap_const_lv11_280 : STD_LOGIC_VECTOR (10 downto 0) := "01010000000";
    constant ap_const_boolean_1 : BOOLEAN := true;

    signal ap_done_reg : STD_LOGIC := '0';
    signal ap_CS_fsm : STD_LOGIC_VECTOR (0 downto 0) := "1";
    attribute fsm_encoding : string;
    attribute fsm_encoding of ap_CS_fsm : signal is "none";
    signal ap_CS_fsm_state1 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state1 : signal is "none";
    signal img_in_rows_V_out_blk_n : STD_LOGIC;
    signal img_in_cols_V_out_blk_n : STD_LOGIC;
    signal ap_block_state1 : BOOLEAN;
    signal ap_NS_fsm : STD_LOGIC_VECTOR (0 downto 0);


begin




    ap_CS_fsm_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                ap_CS_fsm <= ap_ST_fsm_state1;
            else
                ap_CS_fsm <= ap_NS_fsm;
            end if;
        end if;
    end process;


    ap_done_reg_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                ap_done_reg <= ap_const_logic_0;
            else
                if ((ap_const_logic_1 = ap_continue)) then 
                    ap_done_reg <= ap_const_logic_0;
                elsif (((ap_const_logic_1 = ap_CS_fsm_state1) and not(((ap_const_logic_0 = ap_start) or (ap_const_logic_0 = img_in_rows_V_out_full_n) or (ap_const_logic_0 = img_in_cols_V_out_full_n) or (ap_done_reg = ap_const_logic_1))))) then 
                    ap_done_reg <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    ap_NS_fsm_assign_proc : process (ap_start, ap_done_reg, ap_CS_fsm, ap_CS_fsm_state1, img_in_rows_V_out_full_n, img_in_cols_V_out_full_n)
    begin
        case ap_CS_fsm is
            when ap_ST_fsm_state1 => 
                ap_NS_fsm <= ap_ST_fsm_state1;
            when others =>  
                ap_NS_fsm <= "X";
        end case;
    end process;
    ap_CS_fsm_state1 <= ap_CS_fsm(0);

    ap_block_state1_assign_proc : process(ap_start, ap_done_reg, img_in_rows_V_out_full_n, img_in_cols_V_out_full_n)
    begin
                ap_block_state1 <= ((ap_const_logic_0 = ap_start) or (ap_const_logic_0 = img_in_rows_V_out_full_n) or (ap_const_logic_0 = img_in_cols_V_out_full_n) or (ap_done_reg = ap_const_logic_1));
    end process;


    ap_done_assign_proc : process(ap_start, ap_done_reg, ap_CS_fsm_state1, img_in_rows_V_out_full_n, img_in_cols_V_out_full_n)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state1) and not(((ap_const_logic_0 = ap_start) or (ap_const_logic_0 = img_in_rows_V_out_full_n) or (ap_const_logic_0 = img_in_cols_V_out_full_n) or (ap_done_reg = ap_const_logic_1))))) then 
            ap_done <= ap_const_logic_1;
        else 
            ap_done <= ap_done_reg;
        end if; 
    end process;


    ap_idle_assign_proc : process(ap_start, ap_CS_fsm_state1)
    begin
        if (((ap_const_logic_0 = ap_start) and (ap_const_logic_1 = ap_CS_fsm_state1))) then 
            ap_idle <= ap_const_logic_1;
        else 
            ap_idle <= ap_const_logic_0;
        end if; 
    end process;


    ap_ready_assign_proc : process(ap_start, ap_done_reg, ap_CS_fsm_state1, img_in_rows_V_out_full_n, img_in_cols_V_out_full_n)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state1) and not(((ap_const_logic_0 = ap_start) or (ap_const_logic_0 = img_in_rows_V_out_full_n) or (ap_const_logic_0 = img_in_cols_V_out_full_n) or (ap_done_reg = ap_const_logic_1))))) then 
            ap_ready <= ap_const_logic_1;
        else 
            ap_ready <= ap_const_logic_0;
        end if; 
    end process;


    img_in_cols_V_out_blk_n_assign_proc : process(ap_CS_fsm_state1, img_in_cols_V_out_full_n)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state1)) then 
            img_in_cols_V_out_blk_n <= img_in_cols_V_out_full_n;
        else 
            img_in_cols_V_out_blk_n <= ap_const_logic_1;
        end if; 
    end process;

    img_in_cols_V_out_din <= ap_const_lv11_280;

    img_in_cols_V_out_write_assign_proc : process(ap_start, ap_done_reg, ap_CS_fsm_state1, img_in_rows_V_out_full_n, img_in_cols_V_out_full_n)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state1) and not(((ap_const_logic_0 = ap_start) or (ap_const_logic_0 = img_in_rows_V_out_full_n) or (ap_const_logic_0 = img_in_cols_V_out_full_n) or (ap_done_reg = ap_const_logic_1))))) then 
            img_in_cols_V_out_write <= ap_const_logic_1;
        else 
            img_in_cols_V_out_write <= ap_const_logic_0;
        end if; 
    end process;


    img_in_rows_V_out_blk_n_assign_proc : process(ap_CS_fsm_state1, img_in_rows_V_out_full_n)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state1)) then 
            img_in_rows_V_out_blk_n <= img_in_rows_V_out_full_n;
        else 
            img_in_rows_V_out_blk_n <= ap_const_logic_1;
        end if; 
    end process;

    img_in_rows_V_out_din <= ap_const_lv10_1E0;

    img_in_rows_V_out_write_assign_proc : process(ap_start, ap_done_reg, ap_CS_fsm_state1, img_in_rows_V_out_full_n, img_in_cols_V_out_full_n)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state1) and not(((ap_const_logic_0 = ap_start) or (ap_const_logic_0 = img_in_rows_V_out_full_n) or (ap_const_logic_0 = img_in_cols_V_out_full_n) or (ap_done_reg = ap_const_logic_1))))) then 
            img_in_rows_V_out_write <= ap_const_logic_1;
        else 
            img_in_rows_V_out_write <= ap_const_logic_0;
        end if; 
    end process;

end behav;
